'Asteroids by David 'OddBall' Williamson
'''''''''' '' ''''' ''''''''' ''''''''''
'Powered by PhysLite
'''''''' '' ''''''''
'The Examples are more to show the kinds of things that can be
'acheived using PhysLite than to teach specifics of the module.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

SuperStrict

'Import "PhysLite/PhysLite.bmx"
Import ODD.PhysLite

Const GWIDTH:Int=800
Const GHEIGHT:Int=600

?win32
SetGraphicsDriver GLMax2DDriver()
?
Graphics GWIDTH,GHEIGHT
SetBlend ALPHABLEND
SetLineWidth 2

PhysicsBegin GWIDTH,GHEIGHT,0

Global ship:TAdvBody
CreateShip
ship.Rotate -90

Global roids:TList=New TList
Global roidCount:Int=0
For Local count:Int=0 To 4
	CreateRoid()
Next

Repeat
	
	Local angle:Float=ship.GetRotation()
	Local mx:Float=Cos(angle)*0.1
	Local my:Float=Sin(angle)*0.1
	
	If KeyDown(KEY_LEFT) Then ship.Spin -.1
	If KeyDown(KEY_RIGHT) Then ship.Spin .1
	If KeyDown(KEY_UP) Then ship.Move mx,my
	If KeyHit(KEY_SPACE) Then TBullet.Create
	
	If KeyHit(KEY_A) Then CreateRoid()
	
	TExp.Update
	TBullet.Update
	
	PhysicsUpdate
	
	Cls
	
	DrawShip
	Tbullet.Draw
	DrawRoids
	TExp.Draw
	
	SetColor 0,0,0
	DrawText "Asteroids! by Dave 'Oddball' Williamson",7,7
	DrawText "---------------------------------------",7,23
	DrawText "[Left, Right] - Rotate ship",7,39
	DrawText "[Up] - Thrusters",7,55
	DrawText "[Space] - Fire",7,71
	DrawText "[A] - Add asteroid",7,87
	DrawText "[Esc] - Exit",7,129
	DrawText "Powered by PhysLite",GWIDTH-173,GHEIGHT-28
	SetColor 255,0,255
	DrawText "Asteroids! by Dave 'Oddball' Williamson",5,5
	SetColor 255,31,223
	DrawText "---------------------------------------",5,21
	SetColor 255,63,191
	DrawText "[Left, Right] - Rotate ship",5,37
	SetColor 255,85,159
	DrawText "[Up] - Thrusters",5,53
	SetColor 255,127,127
	DrawText "[Space] - Fire",5,69
	SetColor 255,159,85
	DrawText "[A] - Add asteroid",5,85
	SetColor 255,223,31
	DrawText "[Esc] - Exit",5,127
	SetColor 255,255,255
	DrawText "Powered by",GWIDTH-175,GHEIGHT-30
	SetColor 255,0,0
	DrawText "Phys",GWIDTH-175+88,GHEIGHT-30
	SetColor 0,0,255
	DrawText "    Lite",GWIDTH-175+88,GHEIGHT-30
	Flip
	
Until KeyHit(KEY_ESCAPE)

PhysicsEnd

EndGraphics

End

Function CreateShip()
	ship=New TAdvBody
	ship.MassAdd GWIDTH*.5,GHEIGHT*.5,1,8,1
	ship.MassAdd GWIDTH*.5+20,GHEIGHT*.5,1,1,1
	ship.MassAdd GWIDTH*.5-10,GHEIGHT*.5+10,1,1,1
	ship.MassAdd GWIDTH*.5-10,GHEIGHT*.5-10,1,1,1
	ship.ConAdd 0,1
	ship.ConAdd 0,2
	ship.ConAdd 0,3
	ship.ConAdd 1,2
	ship.ConAdd 1,3
	ship.ConAdd 2,3
	ship.Activate
End Function

Function DrawShip()
	SetColor 0,255,255
	For Local count:Int=0 To ship.ConMaxIndex()
		If ship.ConExists(count)
			Local m1:Int=ship.ConGetMass1(count)
			Local m2:Int=ship.ConGetMass2(count)
			DrawLine ship.MassGetX(m1),ship.MassGetY(m1),ship.MassGetX(m2),ship.MassGetY(m2)
		EndIf
	Next
End Function

Type TBullet
	Global list:TList=New TList
	
	Field x:Float,y:Float
	Field vx:Float,vy:Float
	
	Function Create()
		Local b:TBullet=New TBullet
		
		Local angle:Float=ship.GetRotation()
		
		ship.MassGetPosition 1,b.x,b.y
		b.vx=ship.MassGetVX(0)+Cos(angle)*2
		b.vy=ship.MassGetVY(0)+Sin(angle)*2
		
		list.AddLast b
	End Function
	
	Function Update()
		For Local b:TBullet=EachIn list
			b.x:+b.vx;b.y:+b.vy
			If b.x<0 Or b.x>GWIDTH Or b.y<0 Or b.y>GHEIGHT
				list.Remove b
			Else
				For Local a:TAdvBody=EachIn roids
					For Local index:Int=0 To a.MassMaxIndex()
						If a.MassExists(index)
							Local mx:Float=a.MassGetX(index)
							Local my:Float=a.MassGetY(index)
							If (b.x-mx)*(b.x-mx)+(b.y-my)*(b.y-my)<400
								TExp.Create a.MassGetX(index),a.MassGetY(index)
								a.MassRemove index
								If a.GetConstraints().IsEmpty()
									a.Free
									roids.Remove a
									roidCount:-1
								EndIf
								TExp.Create b.x,b.y
								list.Remove b
								Exit
							EndIf
						EndIf
					Next
				Next
			EndIf
		Next
	End Function
	
	Function Draw()
		SetColor 0,255,0
		For Local b:TBullet=EachIn list
			DrawLine b.x,b.y,b.x-b.vx,b.y-b.vy
		Next
	End Function
End Type

Function CreateRoid()
	If roidCount>=20 Then Return
	
	roidCount:+1
	Local a:TAdvBody=New TAdvBody
	
	Local x:Float=Rnd(50,GWIDTH-50)
	Local y:Float=Rnd(50,GHEIGHT-50)
	
	a.MassAdd x+Rnd(-20,20),y+Rnd(-20,20),2,20,1
	For Local count:Int=0 To 2
		a.MassAdd x+Rnd(-20,20),y+Rnd(-20,20),2,20,1,a.MassGetColGroup(0)
	Next
	a.ConAddAll
	a.Activate
	a.Spin Rnd(-2,2)
	a.Move Rnd(-1,1),Rnd(-1,1)
	
	roids.AddLast a
End Function

Function DrawRoids()
	SetColor 255,127,0
	For Local a:TAdvBody=EachIn roids
		For Local index:Int=0 To a.MassMaxIndex()
			If a.MassExists(index)
				DrawOval a.MassGetX(index)-20,a.MassGetY(index)-20,40,40
			EndIf
		Next
	Next
EndFunction

Type TExp
	Global list:TList=New TList
	
	Field x:Float,y:Float
	Field ang:Float,scl:Float=1.0
	Field alpha:Float=1.0
	
	Function Create(x:Float,y:Float)
		Local xp:TExp=New TExp
		
		xp.x=x;xp.y=y
		xp.ang=Rnd(-180,180)
		
		list.AddLast xp
	End Function
	
	Function Update()
		For Local xp:TExp=EachIn list
			xp.alpha:-.02
			If xp.alpha>0
				xp.ang:+2
				xp.scl:*1.03
			Else
				list.Remove xp
			EndIf
		Next
	End Function
	
	Function Draw()
		SetColor 255,255,255
		SetHandle 10,10
		
		For Local xp:TExp=EachIn list
			SetScale xp.scl,xp.scl
			SetRotation xp.ang
			SetAlpha xp.alpha
			DrawRect xp.x,xp.y,20,20
		Next
		
		SetAlpha 1
		SetRotation 0
		SetScale 1,1
		SetHandle 0,0
	End Function
End Type