'Spire of Ooze by David 'OddBall' Williamson
'''''' '' '''' '' ''''' ''''''''' ''''''''''
'Powered by PhysLite
'''''''' '' ''''''''
'The Examples are more to show the kinds of things that can be
'acheived using PhysLite than to teach specifics of the module.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'Always SuperStrict
SuperStrict

'Framework
?win32
Framework BRL.D3D7Max2D
?Not win32
Framework BRL.GLMax2D
?
Import BRL.RamStream
Import BRL.PNGLoader
Import BRL.WAVLoader
Import BRL.EventQueue
Import BRL.FreeAudioAudio
Import BRL.Random
Import MaxGUI.MaxGUI
Import BRL.Timer
Import BRL.FreeTypeFont

Import MaxGUI.Drivers
Import ODD.PhysLite

'Include media into binary file
Incbin "media/ooze.plb"
Incbin "media/blob.png"
Incbin "media/goo.png"
Incbin "media/ghostblob.png"
Incbin "media/ghostgoo.png"
Incbin "media/del.png"
Incbin "media/ground.plz"
'SFX copyright of indiesfx.co.uk used under license
'Incbin "media/AlienSquidge02.wav"
'Incbin "media/AlienSquidge06.wav"
Incbin "media/zincboom.ttf"
Incbin "media/physlitelogo.png"

'Constants
Const MAXGOOLENGTH:Int=100
Const MINGOOLENGTH:Int=50
Const P_WIDTH:Int=1024
Const P_HEIGHT:Int=4096

'Globals
Global window:TGadget
Global canvas:TGadget
Global timer:TTimer
Global ground:TZone[3]
Global ooze:TOoze
Global xSquish:Int
Global ySquish:Int
Global screenY:Float
Global mx:Float
Global my:Float
Global rHeight:Float
Global font:TImageFont
Global logo:TImage
Global tCount:Int
'Global squelch1:TSound
'Global squelch2:TSound

'Start App.
GameInit

'Main loop
Repeat
	'Wait for events
	WaitEvent
	'Manually check timer. Timer events are bad!!
	Local t:Int=timer.Ticks()-tCount
	If t
		PhysicsUpdate
		DrawCanvas
		tCount=timer.Ticks()
	EndIf
Forever

'Types
Type TOoze
	'Advanced Body
	Field ab:TAdvBody=AdvBodyLoad("incbin::media/ooze.plb",True)
	
	'Images
	Field blob:TImage=LoadImage("incbin::media/blob.png",FILTEREDIMAGE|MIPMAPPEDIMAGE)
	Field goo:TImage=LoadImage("incbin::media/goo.png",FILTEREDIMAGE|MIPMAPPEDIMAGE)
	Field ghostblob:TImage=LoadImage("incbin::media/ghostblob.png",FILTEREDIMAGE|MIPMAPPEDIMAGE)
	Field ghostgoo:TImage=LoadImage("incbin::media/ghostgoo.png",FILTEREDIMAGE|MIPMAPPEDIMAGE)
	Field del:TImage=LoadImage("incbin::media/del.png",FILTEREDIMAGE|MIPMAPPEDIMAGE)
	
	'Create ooze
	Function Create:TOoze()
		Local o:TOoze=New TOoze
		o.ab.position (P_WIDTH/2.0)-30,P_HEIGHT-190
		MidHandleImage o.blob
		SetImageHandle o.goo,0,16
		MidHandleImage o.ghostblob
		SetImageHandle o.ghostgoo,0,16
		MidHandleImage o.del
		Return o
	End Function
	
	'Add/remove blob
	Method Add( x:Float, y:Float )
		'Index of closest blob to mouse pointer
		Local closest:Int=-1
		'Distance of closest blob
		Local cDist:Float=1000000
		'Array of blobs close to mouse pointer
		Local near:Int[512]
		Local cCount:Int=0
		
		'Find closest and close blobs
		For Local count:Int=0 To ab.MassMaxIndex()
			If ab.MassExists(count)
				Local mx:Float=ab.MassGetX(count)
				Local my:Float=ab.MassGetY(count)
				Local dist:Float=(mx-x)*(mx-x)+(my-y)*(my-y)
				If dist<cDist
					closest=count
					cDist=dist
				EndIf
				If dist<MAXGOOLENGTH*MAXGOOLENGTH And dist>MINGOOLENGTH*MINGOOLENGTH
					'Check goo won't cross other strands
					Local crossed:Int=False
					For Local count2:Int=0 To ab.ConMaxIndex()
						If ab.ConExists(count2)
							Local m1:Int=ab.ConGetMass1(count2)
							Local m2:Int=ab.ConGetMass2(count2)
							If LinesCross(x,y,mx,my,ab.MassGetX(m1),ab.MassGetY(m1),ab.MassGetX(m2),ab.MassGetY(m2))
								crossed=True
								Exit
							EndIf
						EndIf
					Next
					If Not crossed
						near[cCount]=count
						cCount:+1
					EndIf
				EndIf
			EndIf
		Next
		'Check if blob is close enough to remove
		cDist=Sqr(cDist)
		If cDist<=10
			ab.MassRemove closest
			'PlaySound squelch1
		'Check if there are enough strands to add blob
		ElseIf cCount>1 And cDist>MINGOOLENGTH
			Local ind1:Int=ab.MassAdd(x,y,10,10,1,1)
			For Local count:Int=0 To cCount-1
				Local cInd:Int=ab.ConAdd(ind1,near[count],,.5)
				ab.ConAssign cInd
			Next
			'PlaySound squelch2
		EndIf	
	End Method
	
	'Draw ooze
	Method Draw:Float()
		'Calc and draw white strands
		Local closest:Int=-1
		Local cDist:Float=1000000
		Local near:Int[512]
		Local cCount:Int=0
		Local px:Float=PhysicsSimX(mx,my)
		Local py:Float=PhysicsSimY(mx,my)
		For Local count:Int=0 To ab.MassMaxIndex()
			If ab.MassExists(count)
				Local x:Float=ab.MassGetX(count)
				Local y:Float=ab.MassGetY(count)
				Local dist:Float=(px-x)*(px-x)+(py-y)*(py-y)
				If dist<cDist
					closest=count
					cDist=dist
				EndIf
				If dist<MAXGOOLENGTH*MAXGOOLENGTH And dist>MINGOOLENGTH*MINGOOLENGTH
					Local crossed:Int=False
					For Local count2:Int=0 To ab.ConMaxIndex()
						If ab.ConExists(count2)
							Local m1:Int=ab.ConGetMass1(count2)
							Local m2:Int=ab.ConGetMass2(count2)
							If LinesCross(x,y,px,py,ab.MassGetX(m1),ab.MassGetY(m1),ab.MassGetX(m2),ab.MassGetY(m2))
								crossed=True
								Exit
							EndIf
						EndIf
					Next
					If Not crossed
						near[cCount]=count
						cCount:+1
					EndIf
				EndIf
			EndIf
		Next
		SetColor 255,255,255
		'If deleting hide mouse
		cDist=Sqr(cDist)
		If cDist<=10
			HideMouse
		'Draw white goo
		ElseIf cCount>1 And cDist>MINGOOLENGTH
			HideMouse
			For Local count:Int=0 To cCount-1
				Local x:Float=ab.MassGetX(near[count])
				Local y:Float=ab.MassGetY(near[count])
				Local length:Float=Sqr((px-x)*(px-x)+(py-y)*(py-y))
				SetScale length/100,1
				SetRotation ATan2((y-py),(x-px))
				PhysicsDrawImage ghostgoo,px,py
			Next
			PhysicsDrawImage ghostblob,px,py
		'Do neither of the above
		Else
			ShowMouse
		EndIf
		
		'Draw goo strands
		SetColor 255,255,255
		For Local count:Int=0 To ab.ConMaxIndex()
			If ab.ConExists(count)
				SetScale ab.ConGetLength(count)/100,1
				SetRotation ab.ConGetAngle(count)
				Local m:Int=ab.ConGetMass1(count)
				PhysicsDrawImage goo,ab.MassGetX(m),ab.MassGetY(m)
			EndIf
		Next
		
		'Draw goo blobs
		SetRotation 0
		xSquish:+8;ySquish:+16
		SeedRnd 0
		SetColor 255,255,255
		Local tHeight:Float=P_HEIGHT
		Local tBlob:Int
		For Local count:Int=0 To ab.MassMaxIndex()
			SetScale 1.1+Cos(Rnd(0,360)+xSquish)*.05,1.2+Sin(Rnd(0,360)+xSquish)*.1
			If ab.MassExists(count)
				If ab.MassIsActive(count)
					If ab.MassGetY(count)<tHeight
						tBlob=count
						tHeight=ab.MassGetY(count)
					EndIf
					PhysicsDrawImage blob,ab.MassGetX(count),ab.MassGetY(count)
				Else
					ab.MassRemove(count)
				EndIf
			EndIf
		Next
		
		'Draw delete icon
		SetScale 1,1
		If cDist<=10
			Local x:Float=ab.MassGetX(closest)
			Local y:Float=ab.MassGetY(closest)
			PhysicsDrawImage del,x,y
		EndIf
		
		'Return highest point
		If ab.MassExists(tBlob)
			tHeight:-10
			Return tHeight
		Else
			Return P_HEIGHT
		EndIf
	End Method
End Type

'Functions
Function GameInit()
	'Create gadgets
	window=CreateWindow("Spire of Ooze by David Williamson",0,0,450,600,Null,WINDOW_TITLEBAR|WINDOW_RESIZABLE|WINDOW_CENTER)
	canvas=CreateCanvas(0,0,ClientWidth(window),ClientHeight(window),window)
	SetGadgetLayout canvas,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
	'Set timer
	timer=CreateTimer(60)
	
	'Hook gadget and physics events
	AddHook EmitEventHook,DoGadgetEvents
	AddHook TColEvent.Hook,DoPhysicsEvents
	
	'Start PhysLite
	PhysicsBegin P_WIDTH,P_HEIGHT,.1,,1
	
	'Create ground
	ground[0]=ZoneLoad("incbin::media/ground.plz")
	ground[0].Position P_WIDTH/2.0,P_HEIGHT
	ground[1]=ground[0].Copy()
	ground[1].Position P_WIDTH,P_HEIGHT-2000
	ground[1].Rotate -70
	ground[2]=ground[0].Copy()
	ground[2].Position 0,P_HEIGHT-5000
	ground[2].Rotate 70
	
	
	'Create ooze
	ooze=TOoze.Create()
	
	'Init. values
	screenY=P_HEIGHT
	rHeight=P_HEIGHT
	
	'Load misc. media
	'squelch1=LoadSound("incbin::media/AlienSquidge02.wav")
	'squelch2=LoadSound("incbin::media/AlienSquidge06.wav")
	font=LoadImageFont("incbin::media/zincboom.ttf",35)
	logo=LoadImage("incbin::media/physlitelogo.png",FILTEREDIMAGE|MIPMAPPEDIMAGE)
	
	'Activate window
	ActivateGadget window
	MaximizeWindow window
	
End Function

'Gadget events
Function DoGadgetEvents:Object( id:Int, data:Object, context:Object )
	Local event:TEvent=TEvent(data)
	Select event.ID
	Case EVENT_WINDOWSIZE
		'Draws canvas whilst resizing
		RedrawGadget canvas
	Case EVENT_WINDOWCLOSE
		'Bye bye
		PhysicsEnd
		EndGraphics
		End
	Case EVENT_MOUSEDOWN
		'Add/remove blobs
		ooze.Add PhysicsSimX(event.x,event.y),PhysicsSimY(event.x,event.y)
	Case EVENT_MOUSEMOVE
		'Track mouse position
		mx=event.x
		my=event.y
	Case EVENT_GADGETPAINT
		'Draw canvas
		DrawCanvas
	End Select
	Return data
End Function

'Physics events
Function DoPhysicsEvents:Object( id:Int, data:Object, context:Object )
	Local colEvent:TColEvent=TColEvent(data)
	Select colEvent.GetID()
	Case TColEvent.MASS_BOUNDS
		'Remove blob
		Local m:TMass=colEvent.GetMass1()
		ooze.ab.MassRemove m.index
		'PlaySound squelch1
	Case TColEvent.MASS_ZONE
		'Stick to ground
		Local m:TMass=colEvent.GetMass1()
		If Not m.IsFrozen()
			m.Freeze
			'PlaySound squelch2
		EndIf
	Case TColEvent.MASS_MASS
		'Not needed
	End Select
	
	Return data
End Function

'Draw game
Function DrawCanvas()
	'Set up graphics
	SetGraphics CanvasGraphics(canvas)
	Local gWidth:Float=GraphicsWidth()
	Local gHeight:Float=GraphicsHeight()
	SetViewport 0,0,gWidth,gHeight
	
	'Check for scrolling
	If my<32
		screenY:-5
	ElseIf my>gHeight-32
		screenY:+5
	EndIf
	
	'Position and scale view
	PhysicsSetDrawZoom gWidth/P_WIDTH
	PhysicsSetDrawCoords P_WIDTH/2.0,screenY
	Local botY:Float=PhysicsSimY(0,gHeight)
	If botY>P_HEIGHT Then screenY:+(P_HEIGHT-botY)
	PhysicsSetDrawCoords P_WIDTH/2.0,screenY
	
	'Pre draw
	SetImageFont font
	SetBlend ALPHABLEND
	SetClsColor 127,127,255
	Cls
	
	'Draw ground
	For Local count:Int=0 To 2
		ground[count].Draw
	Next
	
	'Draw ooze
	Local tHeight:Float=ooze.Draw()
	
	'Draw records
	rHeight=Min(tHeight,rHeight)
	Local rec:Float=P_HEIGHT-rHeight
	Local sy:Float=PhysicsScreenY(0,rHeight)
	SetColor 0,255,0
	SetLineWidth 2
	DrawLine 0,sy,gWidth,sy
	DrawText Int(rec),gWidth-10-TextWidth(Int(rec)),Max(5,sy)
	sy=PhysicsScreenY(0,tHeight)
	SetColor 255,0,0
	DrawLine 0,sy,gWidth,sy
	screenY=Max(tHeight,screenY)
	tHeight=P_HEIGHT-tHeight
	DrawText Int(tHeight),10,Max(5,sy)
	SetLineWidth 1
	
	'Advertise
	SetColor 255,255,255
	SetScale .5,.5
	DrawImage logo,gWidth-90,gHeight-70
	SetScale 1,1
	
	Flip
	
	'Make sure there's enough room
	PhysicsSetBounds 0,rHeight-1000,P_WIDTH,P_HEIGHT
End Function
'Rem
'Thanks Fredborg
Function LinesCross:Int( x0:Float, y0:Float , x1:Float, y1:Float, x2:Float ,y2:Float, x3:Float, y3:Float )
	Local n:Float=(y0-y2)*(x3-x2)-(x0-x2)*(y3-y2)
	Local d:Float=(x1-x0)*(y3-y2)-(y1-y0)*(x3-x2)
	If Abs(d) < 0.0001 
		' Lines are parallel!
		Return False
	Else
		' Lines might cross!
		Local Sn:Float=(y0-y2)*(x1-x0)-(x0-x2)*(y1-y0)

		Local AB:Float=n/d
		If AB>0.0 And AB<1.0
			Local CD:Float=Sn/d
			If CD>0.0 And CD<1.0
				' Intersection Point
				Local X:Int=x0+AB*(x1-x0)
		       	Local Y:Int=y0+AB*(y1-y0)
				Return True
			End If
		End If
	
		' Lines didn't cross, because the intersection was beyond the end points of the lines
	EndIf

	' Lines do Not cross!
	Return False
End Function
Rem
Function LinesCross:Int(x1#,y1#,x2#,y2#,x3#,y3#,x4#,y4#)
	'New LinesCross code thanks to Jake
	Local dpx#= x3 - x1 + x4 - x2
	Local dpy#= y3 - y1 + y4 - y2
	Local qax#= x2 - x1
	Local qay#= y2 - y1
	Local qbx#= x4 - x3
	Local qby#= y4 - y3
	Local d#= qay*qbx - qby*qax
	Local la# = qbx*dpy - qby*dpx
	Local lb# = qax*dpy - qay*dpx
	Return (Abs(la)<=Abs(d) And Abs(lb)<=Abs(d))
End Function
EndRem
