'Tutorial03: More boxes
'''''''''''''''''''''''
'By David 'OddBall' Williamson
''''''''''''''''''''''''''''''
'18th May 2007 - Revised 3rd Feb 2009
'''''''''''''''''''''''''''''''''''''
'Description
''''''''''''
'Extending the TBody object to help create reusable objects.
'
'This tutorial assumes you have read all previous tutorials in the series
'and as such only parts where code has changed will be commented.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

SuperStrict

Framework BRL.GLMax2D
'Import "PhysLite/PhysLite.bmx"
Import ODD.PhysLite

?win32
SetGraphicsDriver GLMax2DDriver()
?
Graphics 800,600,,60

'Lets make a slight change to the Physics function.
'The first three params. stay the same and we skip the fourth.
'The fifth param. is the iterations and we've doubled
'it to 2 for a more accurate simulation.
PhysicsBegin 800,600,0.1,,2

'This time we'll store all the TMass and TConstraint objects in TLists.
Global mlist:TList=New TList
Global clist:TList=New TList
'And we'll make a list for our new TBox Objects too.
Global blist:TList=New TList

'Lets make our new box object then. We start by extending TBody
Type TBox Extends TBody
	
	'Now we need a creation function.
	'It's almost identical to our first version except this time
	'each TMass and TConstraint object is added to the relivent list.
	Function Create:TBox( x:Float,y:Float )
		Local box:TBox=New TBox
		
		Local mass:TMass[4]
		mass[0]=MassCreate(x-10,y-10,10,20,1)
		mass[1]=MassCreate(x+10,y-10,10,20,1,mass[0].GetColGroup())
		mass[2]=MassCreate(x-10,y+10,10,20,1,mass[0].GetColGroup())
		mass[3]=MassCreate(x+10,y+10,10,20,1,mass[0].GetColGroup())
		
		For Local count:Int=0 To 3
			mlist.AddLast mass[count]
		Next
		
		Local con:TConstraint[6]
		con[0]=ConCreate(mass[0],mass[1])
		con[1]=ConCreate(mass[0],mass[2])
		con[2]=ConCreate(mass[0],mass[3])
		con[3]=ConCreate(mass[1],mass[2])
		con[4]=ConCreate(mass[1],mass[3])
		con[5]=ConCreate(mass[2],mass[3])
		
		For Local count:Int=0 To 5
			con[count].Assign box
			clist.AddLast con[count]
		Next
		
		Return box
	End Function
End Type

'With our new TBox type creating lots of boxes is easy
For Local y:Int=100 To 340 Step 80
	For Local x:Int=80 To 720 Step 80
		blist.AddLast TBox.Create(x,y)
	Next
Next

Global area:Float[]=[450.0,450.0,500.0,500.0,400.0,600.0,350.0,550.0]
Global zone:TZone=ZoneCreate(area,TZone.FILL)

Repeat
	
	PhysicsUpdate
	
	Cls
	SetColor 0,0,255
	For Local m:TMass=EachIn mlist
		m.Draw
	Next
	SetColor 255,255,255
	For Local c:TConstraint=EachIn clist
		c.Draw
	Next
	SetColor 255,0,0
	zone.Draw
	Flip
	
Until KeyHit(KEY_ESCAPE)

PhysicsEnd

EndGraphics

End
'The end
