'Tutorial05: It's picture time
''''''''''''''''''''''''''''''
'By David 'OddBall' Williamson
''''''''''''''''''''''''''''''
'18th May 2007 - Revised 3rd Feb 2009
'''''''''''''''''''''''''''''''''''''
'Description
''''''''''''
'Using TRig to draw physics bodies.
'
'This tutorial assumes you have read all previous tutorials in the series
'and as such only parts where code has changed will be commented.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

SuperStrict

Framework BRL.GLMax2D
Import BRL.PNGLoader
'Import "PhysLite/PhysLite.bmx"
Import ODD.PhysLite

?win32
SetGraphicsDriver GLMax2DDriver()
?
Graphics 800,600,,60

PhysicsBegin 800,600,0.1,,2

Global mlist:TList=New TList
Global clist:TList=New TList
Global blist:TList=New TList

'This is the image we will use. We set the image handle so that it is
'where we want it.
Global image:TImage=LoadImage("media/bmax.png",FILTEREDIMAGE)
SetImageHandle image,20,20
		
'We're going to make a few changes to our TBox object. This will allow
'us to use an image for our boxes intead of circles.
Type TBox Extends TBody
	'The rig stores all the info needed to display the image correctly
	Field rig:TRig
	
	Function Create:TBox( x:Float,y:Float )
		Local box:TBox=New TBox
		
		Local mass:TMass[4]
		mass[0]=MassCreate(x-10,y-10,10,20,1)
		mass[1]=MassCreate(x+10,y-10,10,20,1,mass[0].GetColGroup())
		mass[2]=MassCreate(x-10,y+10,10,20,1,mass[0].GetColGroup())
		mass[3]=MassCreate(x+10,y+10,10,20,1,mass[0].GetColGroup())
		
		Local con:TConstraint[6]
		con[0]=ConCreate(mass[0],mass[1])
		con[1]=ConCreate(mass[0],mass[2])
		con[2]=ConCreate(mass[0],mass[3])
		con[3]=ConCreate(mass[1],mass[2])
		con[4]=ConCreate(mass[1],mass[3])
		con[5]=ConCreate(mass[2],mass[3])
		For Local count:Int=0 To 5
			con[count].Assign box
		Next
		
		'Now let's create our rig. The first param. is the TImage. The second tells
		'the rig where to draw the image. In this case wherever mass[0] is. The final
		'param. tell the TRig at what rotation to draw the image. If this param was 
		'left blank the image would not rotate with the TBody.
		box.rig=RigCreate(image,mass[0],con[0])
		
		Return box
	End Function
	
End Type

For Local y:Int=100 To 340 Step 80
	For Local x:Int=80 To 720 Step 80
		blist.AddLast TBox.Create(x,y)
	Next
Next

'We move the bride creation to a function to keep it out of the way.
Global start:TMass
Global finish:TMass
Global bridge:TBody
CreateBridge()

Repeat
	
	PhysicsUpdate
	
	Cls
	
	'We need to make a few changes to the drawing routine.
	
	'Set the color to white
	SetColor 255,255,255
	For Local b:TBox=EachIn blist
		'Now draw all the boxes using TRig
		b.rig.Draw
	Next
	'And that's it. simple.
	
	'I've hidden the rest of the draw routine in a function to avoid confusion.
	DrawTheRest
	
	Flip
	
Until KeyHit(KEY_ESCAPE)

PhysicsEnd

EndGraphics

End
'The end

Function CreateBridge()
	bridge=New TBody
	start=MassCreate(240,400,10,20,1,99)
	finish=MassCreate(560,400,10,20,1,99)
	Local m1:TMass=start
	Local m2:TMass
	Local c:TConstraint
	For Local x:Int=240 To 560 Step 40
		m2=MassCreate(x,440,10,20,1,99)
		c=ConCreate(m1,m2)
		c.Assign bridge
		mlist.AddLast m2
		clist.AddLast c
		m1=m2
	Next
	c=ConCreate(m1,finish)
	c.Assign bridge
	clist.AddLast c
	start.Freeze
	finish.Freeze
End Function

Function DrawTheRest()
	SetColor 0,0,255
	For Local m:TMass=EachIn mlist
		m.Draw
	Next
	SetColor 255,0,0
	start.Draw
	finish.Draw
	SetColor 255,255,255
	For Local c:TConstraint=EachIn clist
		c.Draw
	Next
End Function
