'Tutorial13: I'll Be Back.
''''''''''''''''''''''''''
'By David 'OddBall' Williamson
''''''''''''''''''''''''''''''
'26th June 2007 - Revised 4th Feb 2009
''''''''''''''''''''''''''''''''''''''
'Description
''''''''''''
'So far TAdvBody hasn't shown us anything new. So now lets take a look at
'one of TAdvBody's greatest strengths. Loading and saving.
'
'This tutorial assumes you have read all previous tutorials in the series
'and as such only parts where code has changed will be commented.
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

SuperStrict

Framework BRL.GLMax2D
Import BRL.Random
'Import "PhysLite/PhysLite.bmx"
Import ODD.PhysLite

?win32
SetGraphicsDriver GLMax2DDriver()
?
Graphics 800,600,,60

PhysicsBegin 800,600,0.1,,1

Global body:TAdvBody=New TAdvBody
For Local count:Int=0 To 5
	body.MassAdd(Rnd(300,500),Rnd(200,400),10,10,1,1)
Next
body.ConAddAll 0.5
body.Activate

Repeat
	
	'First let's look at saving.
	If KeyHit(KEY_S) Then body.Save("./Media/tut13.plb",False)
	'Wow! That was easy. It's as simple as choosing a file name.
	'The second parameter just tells PhysLite not to make a backup
	'if "tut13.plb" already exists. If we left the extension off
	'then PhysLite adds the default ".plb" extension, but you can
	'use any extension you like.
	
	'Now lets look at loading.
	If KeyHit(KEY_L)
		'First we need to get rid of the body that already exists.
		body.Clear
		'Loading is almost as easy as saving.
		body=AdvBodyLoad("./Media/tut13.plb",True)
		'The first parameter is the file name. The second tells
		'PhysLite to activate the TAdvBody immediately. If we were
		'loading "tut13.plb" to use as a templete for create lots of
		'bodies then we would leave that parameter as false.
		body.Position 400,300
		'Save and load act on the TAdvBody's current location,
		'orientation, and velocity so we need to move our loaded
		'TAdvBody to the center of the simulation.
	EndIf
	
	Local mx:Int=MouseX()
	Local my:Int=MouseY()
	Local button:Int=0
	If MouseDown(MOUSE_LEFT) Then button=1
	If MouseDown(MOUSE_RIGHT) Then button=2
	
	Local nearDist:Float=400
	Local nearMass:Int=-1
	If button=1
		For Local index:Int=0 To body.MassMaxIndex()
			If body.MassExists(index)
				Local dist:Float=(body.MassGetX(index)-mx)*(body.MassGetX(index)-mx)..
									+(body.MassGetY(index)-my)*(body.MassGetY(index)-my)
				If dist<nearDist
					nearDist=dist
					nearMass=index
				EndIf
			EndIf
		Next
		If nearMass>-1 Then body.MassPosition nearMass,mx,my
	ElseIf button=2
		For Local index:Int=0 To body.MassMaxIndex()
			Local dist:Float=(body.MassGetX(index)-mx)*(body.MassGetX(index)-mx)..
								+(body.MassGetY(index)-my)*(body.MassGetY(index)-my)
			If dist<nearDist
				nearDist=dist
				nearMass=index
			EndIf
		Next
		If nearMass>-1
			body.MassPosition nearMass,mx,my
			For Local index:Int=0 To body.ConMaxIndex()
				If body.ConExists(index)
					If body.ConGetMass1(index)=nearMass Or body.ConGetMass2(index)=nearMass
						body.ConSetRestLength index
					EndIf
				EndIf
			Next
		EndIf
	EndIf
	
	If button<>2 Or nearMass=-1 Then PhysicsUpdate
	
	SetClsColor 127,127,127
	Cls
	
	SetColor 0,0,255
	body.MassDrawAll
	SetColor 255,0,0
	If nearMass>-1 Then body.MassDraw nearMass
	SetColor 255,255,255
	For Local index:Int=0 To body.ConMaxIndex()
		Local m1:Int=body.ConGetMass1(index)
		Local m2:Int=body.ConGetMass2(index)
		If button=2 And (m1=nearMass Or m2=nearMass)
			SetColor 0,255,0
		Else
			SetColor 255,255,255
		EndIf
		body.ConDraw index
	Next
	
	SetColor 0,0,0
	DrawText "[S]ave TAdvBody.",7,7
	DrawText "[L]oad TAdvBady.",7,23
	SetColor 255,255,255
	DrawText "[S]ave TAdvBody.",5,5
	DrawText "[L]oad TAdvBady.",5,21
	
	Flip
	
Until KeyHit(KEY_ESCAPE)

PhysicsEnd

EndGraphics

End
'The end
